/***********************************************************************
* Nazov suboru: Checksuma.cs
* Autor: Michal Pazitny
* Datum vytvorenia: 10.4.2008
* 
* Popis:  vypocet kontrolnej sumy pre pole bajtov
* Funkcie:  pouzije sa pri kontrole odosielania dokumentu na server
***********************************************************************/

using System;
using System.Collections.Generic;
using System.Text;

namespace Foobe
{
    public static class Checksuma
    {
        // porovnanie dvoch checksum (poli bytov)
        public static bool porovnajChecksumy(byte[] a, byte[] b)
        {
            if (a.Length != b.Length) return false;

            for (long i = 0; i < a.Length; i++)
                if (a[i] != b[i]) return false;

            return true;
        }

        // prevod checksumy z pola bytov do retazca (pre informativne ucely:)
        public static string checksumaDoString(byte[] a)
        {
            string retazec = "";
            foreach (char b in a) retazec += b;

            return retazec;
        }

    }
}
