/***********************************************************************
* Nazov suboru: Dokument.cs
* Autor: Zdenko Porubcan, Michal Pazitny
* Datum vytvorenia: 16.12.2007
* 
* Popis:  zakladne struktury pre pracu s dokumentmi a vysledkami
***********************************************************************/

using System;
using System.Collections.Generic;
using System.Text;

namespace Foobe
{
    // struktura, v ktorej sa vratia vysledky vyhladavani
    public struct Vysledok
    {
        public int id;
        public string nazov;
        public string autor;
        public string subor;
        public string kategoria;
        public float relevancia;
        public string sposobVyhladania;
        public string ukazka;
        // sposob vyhladania ma nasledovny format "abcd"; kde je 1, ten sposob bol pouzity
        // a - podla dotazu
        // b - podla kategorii
        // c - podla grafovych algoritmov
        // d - podla socialnych sieti
    }

    public struct VysledokModulu
    {
        public int id;
        public float relevancia;
    }

    public class Dokument
    {
        private int dokumentID;
        private string nazov;
        private string subor;
        private string autor;
        private string kategoria;
        private float relevancia;

        // konstruktor 
        public Dokument(int id, string nd, string ns, string aut, string kat, float r)
        {
            dokumentID = id;
            nazov = nd;
            subor = ns;
            autor = aut;
            kategoria = kat;
            relevancia = r;
        }

        // vratenie ID dokumentu
        public int VratID()
        {
            return dokumentID;
        }

        // vratenie nazvu dokumentu
        public string VratNazov()
        {
            return nazov;
        }

        // vratenie nazvu suboru
        public string VratSubor()
        {
            return subor;
        }

        // vratenie autora
        public string VratAutora()
        {
            return autor;
        }

        // vratenie kategorie
        public string VratKategoriu()
        {
            return kategoria;
        }

        // vratenie relevancie
        public float VratRelevanciu()
        {
            return relevancia;
        }

        // nastavenie relevancie
        public void NastavRelevanciu(float rel)
        {
            this.relevancia = rel;
        }
    }

    /*************************************************************************
    * trieda obsahujuca udaje o prepojeni medzi dvoma subormi
    * ***********************************************************************/
    public class Prepojenie
    {
        public int dokument_ID;
        public int typ;
        public float relevancia;

        public int vratDokument()
        {
            return this.dokument_ID;
        }

    }
}
