using System;
using System.Collections.Generic;
using System.Text;

using System.IO;

using System.Data;
using System.Data.SqlClient;

namespace Foobe
{
     /*************************************************************************
     * 
     * trieda obsahujuca udaje o subore
     * 
     * ***********************************************************************/
    public class Zaznam{
        public int ID;
        public String nazov;
        public String autor;
        public String kategoria;
        public byte[] subor;
    }

    /************************************************************************************
    * 
    * Trieda obsahujuca informacie o pouzivatelovi
    * 
    * **********************************************************************************/
    public class Pouzivatel
    {
        public int ID;
        public String login;
        public String heslo;
        public float vaha1;
        public float vaha2;
        public float vaha3;
        public float vaha4;
        public string vahyKategorii;
    }

    /*************************************************************************
     * 
     * trieda pre pracu s databazou
     * 
     * ***********************************************************************/
    public class DB
    {
        String server;
        String databaza;
        String login;
        String heslo;
        String conn_string;
        bool debug = true;

        /*************************
         * Pripojenie na databazu
         * ***********************/
        public void pripojSa(String server, String databaza, String login, String heslo)
        {
            String conn_string = "Data Source = " + server + "; Initial Catalog =" + databaza + "; user = " + login + "; password=" + heslo + ";";
            SqlConnection conn = new SqlConnection(@conn_string);

            Console.WriteLine(conn.State);
            Console.WriteLine(conn.ConnectionString);
            try
            {
                conn.Open();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
            }

            if (conn.State == ConnectionState.Open)
            {
                Console.WriteLine("Pripojenie uspesne");

                this.server = server;
                this.databaza = databaza;
                this.login = login;
                this.heslo = heslo;
                this.conn_string = conn_string;
            }
            else
            {
                Console.WriteLine("Nepodarilo sa propojit na server: "+server+" databazu: "+databaza+" s pouzivatelskym menom: "+login);
            }

            conn.Close();
            
        }

        /*************************************************************************************
         * otestovanie spojenia
         * ***********************************************************************************/
        public bool otestujSpojenie()
        {
            SqlConnection conn = new SqlConnection(@conn_string);
            conn.Open();
            try
            {
                if (conn.State == ConnectionState.Open)
                    return true;
                return false;
            }
            finally
            {
                conn.Close();
            }
        }

        /*************************************************************************************
         * overenie pouzivatela a jeho hesla
         * ***********************************************************************************/
        public bool overLogin(string login, string heslo)
        {
            SqlConnection conn = new SqlConnection(this.conn_string);
            
            try
            {
                conn.Open();
                Console.WriteLine("Overujem login a heslo");

                String query = "SELECT login,heslo FROM pouzivatel WHERE login = '" + login + "'";
                Console.WriteLine(query);

                SqlCommand prikaz = new SqlCommand(query, conn);

                SqlDataReader reader = null;
                reader = prikaz.ExecuteReader();

                if (!reader.HasRows)
                {
                    Console.WriteLine("login neexistuje");
                    return false;
                }

                reader.Read();
                if(reader["heslo"].ToString() != heslo)
                {
                    Console.WriteLine("zle heslo");
                    return false;
                }

                Console.WriteLine("ok");
                return true;
            }
            finally
            {
                conn.Close();
            }
        }

        /*************************************************************************************
         * vlozi subor a informacie o nom do databazy
         * ***********************************************************************************/
        public void vlozSubor(int ID, String nazov, String autor, string kategoria, byte[] subor)
        {
            SqlConnection conn = new SqlConnection(this.conn_string);
            conn.Open();
            try
            {
                String query = "INSERT INTO subor(ID_lucene, nazov, autor, subor, kategoria) values(" +
                    "'" + ID + "'"
                    + ", '" + nazov + "'"
                    + ", '" + autor + "'"
                    + ", @obsahDokumentu" 
                    + ", '" + kategoria + "'"
                    + ")";

                SqlCommand prikaz = new SqlCommand(query, conn);
                
                SqlParameter parameter = new SqlParameter("@obsahDokumentu", SqlDbType.Image);
                parameter.Value = subor;

                prikaz.Parameters.Add(parameter);
                
                prikaz.ExecuteNonQuery();
                Console.WriteLine("Zaznam pridany");
            }
            finally
            {
                conn.Close();
            }
        }


        /************************************************************************************
         * 
         * vyberie subor z databazy, subor sa vybera na zaklade ID_lucene
         * 
         * **********************************************************************************/
        public Zaznam vyberSubor(int ID)
        {
            Zaznam vratit = new Zaznam();

            //pripojenie na databazu
            SqlConnection conn = new SqlConnection(this.conn_string);
            conn.Open();

            try
            {
                
                String query = "SELECT * FROM subor WHERE ID_lucene='" + ID + "'";
                Console.WriteLine(query);

                SqlDataReader reader = null;

                SqlCommand prikaz = new SqlCommand(query, conn);

                Console.WriteLine("vykonavam query");
                reader = prikaz.ExecuteReader();
                Console.WriteLine("query vykonane");

                while (reader.Read())
                {
                    vratit.ID = (int)reader[1];
                    vratit.nazov = reader[2].ToString();
                    vratit.autor = reader[3].ToString();
                    vratit.subor = (byte[])(reader[4]);
                    vratit.kategoria = reader[5].ToString();
                    Console.WriteLine(reader[1] + " " + reader[2] + " " + reader[3] + " " + reader[4]+ " " + reader[5]);

                    /*for (int i = 0; i < vratit.subor.Length; i++)
                    {
                        Console.Write((char)vratit.subor[i]);
                    }*/
                }
            }
            finally
            {
                conn.Close();
            }


            return vratit;
        }

        /************************************************************************************
         * 
         * odstranienie suboru z databazy podla ID_lucene
         * 
         * **********************************************************************************/
        public void odstranSubor(int ID)
        {
            //pripojenie na databazu
            SqlConnection conn = new SqlConnection(this.conn_string);
            conn.Open();

            try
            {
                String query = "DELETE FROM subor WHERE ID_lucene='" + ID + "'";
                Console.WriteLine(query);

                SqlDataReader reader = null;

                SqlCommand prikaz = new SqlCommand(query, conn);

                Console.WriteLine("vykonavam query");
                reader = prikaz.ExecuteReader();
                Console.WriteLine("query vykonane");
                reader.Close();

                //odstranenie z tabulky prepojeni
                query = "DELETE FROM prepojeniaDokumentov WHERE dok1='" + ID + "'";
                reader = null;
                prikaz = new SqlCommand(query, conn);
                reader = prikaz.ExecuteReader();
                reader.Close();

                query = "DELETE FROM prepojeniaDokumentov WHERE dok2='" + ID + "'";
                reader = null;
                prikaz = new SqlCommand(query, conn);
                reader = prikaz.ExecuteReader();
                reader.Close();

                //odstranenie z tabulky pouzivatelov
                query = "DELETE FROM pocetnostOtvoreni WHERE ID_dokument='" + ID + "'";
                reader = null;
                prikaz = new SqlCommand(query, conn);
                reader = prikaz.ExecuteReader();
                reader.Close();
            }
            finally
            {
                conn.Close();
            }
        }

        /************************************************************************************
        * 
        * test ci existuje pouzivatel s danym menom
        * 
        * **********************************************************************************/
        public bool existujePouzivatel(string login)
        {
            SqlConnection conn = new SqlConnection(this.conn_string);
            conn.Open();
            try
            {
                String query = "SELECT COUNT(*) FROM pouzivatel WHERE login='" + login + "'";

                Console.WriteLine(query);
                // query = "insert into test(val) values('asdfasf')";
                SqlCommand prikaz = new SqlCommand(query, conn);
                
                SqlDataReader reader = null;
                reader = prikaz.ExecuteReader();
                
                if (reader.Read()) return true;
                return false;
            }
            finally
            {
                conn.Close();
            }
        }

        /************************************************************************************
        * 
        * Prida pouzivatela do databazy, a nastavy mu defaultne vahy pre jednotlive moduly
        * 
        * **********************************************************************************/
        public bool pridajPouzivatela(string login, string heslo)
        {
            bool vratit = true;

            if (vratPouzivatelaPodlaLoginu(login) != null)
            {
                Console.WriteLine("Pouzivatela nemozno pridat, pouzivatelske meno uz uz existuje");
                vratit = false;
                return vratit;
            }
            SqlConnection conn = new SqlConnection(this.conn_string);
            conn.Open();
            try
            {
                Console.WriteLine("Pridavam pouzivatela");

                String query = "INSERT INTO pouzivatel(login, heslo, vaha1, vaha2, vaha3, vaha4, vahyKategorii) values("
                    + "'" + login + "'"
                    + ", '" + heslo + "'"
                    + ", " + "0.3333333"
                    + ", " + "1"
                    + "," + "0.3333333"
                    + ", " + "0.3333333"
                    + ", " + "'0 0 0,5 1 0 0,5 1 1 1 2 0 0,5 2 1 0,65 2 2 1 3 0 0,5 3 1 0,1 3 2 0,1 3 3 1 4 0 0,5 4 1 0,1 4 2 0,1 4 3 0,2 4 4 1 5 0 0,5 5 1 0,3 5 2 0,8 5 3 0,1 5 4 0,3 5 5 1 6 0 0,5 6 1 0,1 6 2 0,65 6 3 0,05 6 4 0,3 6 5 0,75 6 6 1 7 0 0,5 7 1 0,1 7 2 0,65 7 3 0,05 7 4 0,3 7 5 0,75 7 6 0,75 7 7 1 8 0 0,5 8 1 0,1 8 2 0,1 8 3 0,75 8 4 0,2 8 5 0,05 8 6 0,05 8 7 0,05 8 8 1'"
                    + ")";

                Console.WriteLine(query);
                // query = "insert into test(val) values('asdfasf')";
                SqlCommand prikaz = new SqlCommand(query, conn);
                prikaz.ExecuteNonQuery();
                
                Console.WriteLine("Pouzivatel pridany");
            }
            finally
            {
                conn.Close();
            }
            return vratit;
        }

        /************************************************************************************
         * 
         * odstranienie suboru z databazy podla ID_lucene
         * 
         * **********************************************************************************/
        public bool odstranPouzivatela(string login)
        {
            //pripojenie na databazu
            SqlConnection conn = new SqlConnection(this.conn_string);
            conn.Open();

            int idPouzivatela = vratIdPouzivatela(login);

            if (idPouzivatela == -1) return false;

            try
            {
                String query = "DELETE FROM pouzivatel WHERE ID='" + idPouzivatela + "'";
                Console.WriteLine(query);
                SqlDataReader reader = null;
                SqlCommand prikaz = new SqlCommand(query, conn);
                reader = prikaz.ExecuteReader();
                reader.Close();
                                
                //odstranenie z tabulky pouzivatelov
                query = "DELETE FROM pocetnostOtvoreni WHERE ID_pouzivatel='" + idPouzivatela + "'";
                reader = null;
                prikaz = new SqlCommand(query, conn);
                reader = prikaz.ExecuteReader();
                reader.Close();
            }
            finally
            {
                conn.Close();
            }
            return true;
        }

        /************************************************************************************
        * 
        * Prida pouzivatela do databazy, a nastavy mu vahy pre jednotlive moduly
        * ak sa pouzivatela podarilo pridata vrati true, ak pouzivatel uz existuje vrati false
        * 
        * **********************************************************************************/
        /*public bool pridajPouzivatela(String login, String heslo, double vaha1, double vaha2, double vaha3, double vaha4)
        {
            bool vratit = true;

            if(vratPouzivatelaPodlaLoginu(login) != null){
                  Console.WriteLine("Pouzivatelske meno uz uz existuje");
                  vratit = false;
                return vratit;
            }
            SqlConnection conn = new SqlConnection(this.conn_string);
            conn.Open();
            try
            {
                Console.WriteLine("Pridavam pouzivatela");

                String query = "INSERT INTO pouzivatel(login, heslo, vaha1, vaha2, vaha3, vaha4) values("
                    + "'" + login + "'"
                    + ", '" + heslo + "'"
                    + ", '" + (float)vaha1 + "'"
                    + ", '" + (float)vaha2 + "'"
                    + ",'" + (float)vaha3 + "'"
                    + ", '" + (float)vaha4 + "'"
                    + ")";
                Console.WriteLine(query);
                // query = "insert into test(val) values('asdfasf')";
                SqlCommand prikaz = new SqlCommand(query, conn);
                prikaz.ExecuteNonQuery();

                Console.WriteLine("Pouzivatel pridany");
            }
            finally
            {
                conn.Close();
            }

            return vratit;
        }*/

        /************************************************************************************
        * 
        * Vrati vahy modulov pre pouzivatela
        * 
        * **********************************************************************************/
        public float[] vratVahyModulov(string login)
        {
            float[] vratit = new float[4];
            SqlConnection conn = new SqlConnection(this.conn_string);
            conn.Open();
            try
            {
                Console.WriteLine("vraciam vahy modulov");

                String query = "SELECT login,vaha1,vaha2,vaha3,vaha4 FROM pouzivatel WHERE login = '" + login + "'";
                Console.WriteLine(query);

                SqlCommand prikaz = new SqlCommand(query, conn);

                SqlDataReader reader = null;
                reader = prikaz.ExecuteReader();

                while (reader.Read())
                {
                    vratit[0] = (float)System.Convert.ToSingle((reader["vaha1"].ToString()));
                    vratit[1] = (float)System.Convert.ToSingle((reader["vaha2"].ToString()));
                    vratit[2] = (float)System.Convert.ToSingle((reader["vaha3"].ToString()));
                    vratit[3] = (float)System.Convert.ToSingle((reader["vaha4"].ToString()));
                }
                Console.WriteLine("ok");

            }
            finally
            {
                conn.Close();
            }
            return vratit;
        }

        /************************************************************************************
        * 
        * Vrati vahy modulov pre pouzivatela
        * 
        * **********************************************************************************/
        public string vratVahyKategorii(string login)
        {
            SqlConnection conn = new SqlConnection(this.conn_string);
            conn.Open();
            try
            {
                Console.WriteLine("vraciam vahy kategorii");

                String query = "SELECT login,vahyKategorii FROM pouzivatel WHERE login = '" + login + "'";
                Console.WriteLine(query);

                SqlCommand prikaz = new SqlCommand(query, conn);

                SqlDataReader reader = null;
                reader = prikaz.ExecuteReader();

                while (reader.Read())
                {
                    return reader["vahyKategorii"].ToString();
                }
            }
            finally
            {
                conn.Close();
            }
            return "";
        }

        /************************************************************************************
        * 
        * Zmeni vahy pre pouzivatela a jeho jednotlive moduly
        * 
        * **********************************************************************************/
        public bool zmenVahyModulov(string pouzivatel, string nova_vaha1, string nova_vaha2, string nova_vaha3, string nova_vaha4)
        {
            bool vratit = false;
            
            SqlConnection conn = new SqlConnection(this.conn_string);
            conn.Open();
            try
            {
                Console.WriteLine("Menim vahy pouzivatela");

                String query = "UPDATE pouzivatel SET "
                    + "vaha1 = " + nova_vaha1 
                    + ", vaha2= " + nova_vaha2
                    + ", vaha3= " + nova_vaha3
                    + ", vaha4 = " + nova_vaha4
                    + " WHERE login='" + pouzivatel + "'";
                Console.WriteLine(query);
                // query = "insert into test(val) values('asdfasf')";
                SqlCommand prikaz = new SqlCommand(query, conn);
                prikaz.ExecuteNonQuery();

                Console.WriteLine("Vahy zmenene");
                vratit = true;
            }
            finally
            {
                conn.Close();                
            }
            return vratit;
        }

        /************************************************************************************
        * 
        * Zmeni vahy kategorii pre pouzivatela
        * 
        * **********************************************************************************/
        public bool zmenVahyKategorii(string pouzivatel, string noveVahy)
        {
            bool vratit = false;

            SqlConnection conn = new SqlConnection(this.conn_string);
            conn.Open();
            try
            {
                Console.WriteLine("Menim vahy kategorii pre pouzivatela");

                String query = "UPDATE pouzivatel SET "
                    + "vahyKategorii = '" + noveVahy + "'"
                    + " WHERE login='" + pouzivatel + "'";
                Console.WriteLine(query);
                // query = "insert into test(val) values('asdfasf')";
                SqlCommand prikaz = new SqlCommand(query, conn);
                prikaz.ExecuteNonQuery();

                Console.WriteLine("Vahy kategorii zmenene");

                vratit = true;
            }
            finally
            {
                conn.Close();                
            }
            return vratit;
        }
        
        /************************************************************************************
        * 
        * Vrati informacie o pouzivatelovi na zaklade jeho ID
        * 
        * **********************************************************************************/
        public Pouzivatel vratPouzivatelaPodlaID(int ID_pouzivatela)
        {
            Pouzivatel vratit = null;
            SqlConnection conn = new SqlConnection(this.conn_string);
            conn.Open();
            try
            {
                Console.WriteLine("Vyhladavam pouzivatela");

                String query = "SELECT * FROM pouzivatel WHERE ID = " + ID_pouzivatela;
                Console.WriteLine(query);

                SqlCommand prikaz = new SqlCommand(query, conn);

                SqlDataReader reader = null;
                reader = prikaz.ExecuteReader();

                while (reader.Read())
                {

                    vratit = new Pouzivatel();
                    vratit.ID = (int)reader["ID"];
                    vratit.login = reader["login"].ToString();
                    vratit.heslo = reader["heslo"].ToString();
                    vratit.vaha1 = (float)System.Convert.ToSingle((reader["vaha1"].ToString()));
                    vratit.vaha2 = (float)System.Convert.ToSingle((reader["vaha2"].ToString()));
                    vratit.vaha3 = (float)System.Convert.ToSingle((reader["vaha3"].ToString()));
                    vratit.vaha4 = (float)System.Convert.ToSingle((reader["vaha4"].ToString()));
                    vratit.vahyKategorii = reader["vahyKategorii"].ToString();
                    Console.WriteLine(vratit.ID + " " + vratit.login + " " + vratit.heslo + " " + vratit.vaha1 + " " + vratit.vaha2 + " " + vratit.vaha3 + " " + vratit.vaha4 + " " + vratit.vahyKategorii);
                 
                }
                Console.WriteLine("Vyhladavanie ukoncene");
                
            }
            finally
            {
                conn.Close();
            }
            return vratit;
        }
        /************************************************************************************
        * 
        * Vrati informacie o pouzivatelovi na zaklade jeho Loginu
        * 
        * **********************************************************************************/
        public Pouzivatel vratPouzivatelaPodlaLoginu(String login_pouzivatela)
        {
            Pouzivatel vratit = null;
            SqlConnection conn = new SqlConnection(this.conn_string);
            conn.Open();
            try
            {
                Console.WriteLine("Vyhladavam pouzivatela");

                String query = "SELECT * FROM pouzivatel WHERE login LIKE '" + login_pouzivatela+"'";
                Console.WriteLine(query);

                SqlCommand prikaz = new SqlCommand(query, conn);

                SqlDataReader reader = null;
                reader = prikaz.ExecuteReader();

                while (reader.Read())
                {

                    vratit = new Pouzivatel();
                    vratit.ID = (int)reader["ID"];
                    vratit.login = reader["login"].ToString();
                    vratit.heslo = reader["heslo"].ToString();
                    vratit.vaha1 = (float)System.Convert.ToSingle((reader["vaha1"].ToString()));
                    vratit.vaha2 = (float)System.Convert.ToSingle((reader["vaha2"].ToString()));
                    vratit.vaha3 = (float)System.Convert.ToSingle((reader["vaha3"].ToString()));
                    vratit.vaha4 = (float)System.Convert.ToSingle((reader["vaha4"].ToString()));
                    vratit.vahyKategorii = reader["vahyKategorii"].ToString();
                    Console.WriteLine(vratit.ID + " " + vratit.login + " " + vratit.heslo + " " + vratit.vaha1 + " " + vratit.vaha2 + " " + vratit.vaha3 + " " + vratit.vaha4 + " " + vratit.vahyKategorii);

                }
                Console.WriteLine("Vyhladavanie ukoncene");

            }
            finally
            {
                conn.Close();
            }
            return vratit;
        }

        /************************************************************************************
        * 
        * vrati id pouzivatela podla loginu
        * 
        * **********************************************************************************/
        public int vratIdPouzivatela(String login)
        {
            int id = -1;
            SqlConnection conn = new SqlConnection(this.conn_string);
            conn.Open();
            try
            {
                Console.WriteLine("Vyhladavam pouzivatela");

                String query = "SELECT ID FROM pouzivatel WHERE login= '" + login + "'";
                Console.WriteLine(query);

                SqlCommand prikaz = new SqlCommand(query, conn);

                SqlDataReader reader = null;
                reader = prikaz.ExecuteReader();

                while (reader.Read())
                {

                    id = (int)reader["ID"];
                    Console.WriteLine(id);

                }
                Console.WriteLine("Vyhladavanie ukoncene");

            }
            finally
            {
                conn.Close();
            }
            return id;
        }

        /************************************************************************************
        * 
        * zisti ci existuje subor podla id z lucennu
        * 
        * **********************************************************************************/
        public bool existujeDokument(int ID)
        {
            SqlConnection conn = new SqlConnection(this.conn_string);
            conn.Open();
            try
            {
                string query = "SELECT ID_lucene FROM subor WHERE ID_lucene = '" + ID + "'";

                SqlCommand prikaz = new SqlCommand(query, conn);

                SqlDataReader reader = null;
                reader = prikaz.ExecuteReader();

                if (debug) Console.WriteLine(query);
                if (debug) Console.WriteLine(reader.HasRows);
                if (reader.HasRows)
                {
                    if (debug) Console.WriteLine("subor existuje");
                    return true;
                }
                else
                {
                    if (debug) Console.WriteLine("subor Neexistuje");
                    return false;
                }
            }
            catch (Exception)
            { return false; }
            finally
            {
                conn.Close();
            }
        }

        /* *********************************************************************************
        *
        * zvysi pocet otvoreni dokumntu pre daneho pouzivatela
        * 
        * **********************************************************************************/
        public void pridajDokumentPouzivatelovi(int dokument, int pouzivatel)
        {
            SqlConnection conn = new SqlConnection(this.conn_string);
            conn.Open();
            try
            {
                if (debug) Console.WriteLine("Zvysujem pocet otvoreni dokumentu");

                string query = "SELECT * FROM pocetnostOtvoreni WHERE "
                + "ID_pouzivatel = " +pouzivatel +" AND "
                + "ID_dokument = " + dokument + "";
                if (debug) Console.WriteLine(query);

                SqlCommand prikaz = new SqlCommand(query, conn);

                SqlDataReader reader = null;
                reader = prikaz.ExecuteReader();

                //zaznam uz existuje len updatneme
                if (reader.HasRows)
                {
                    if (debug) Console.WriteLine("Updatujem hodnoty");
                    reader.Read();
                    int pocet_otvoreni = (int)reader["pocetnost"];
                    pocet_otvoreni++;

                    conn.Close();
                    conn = new SqlConnection(this.conn_string);
                    conn.Open();
                    query = "UPDATE pocetnostOtvoreni SET pocetnost ="
                        +pocet_otvoreni
                        +" WHERE ID_pouzivatel = '" +pouzivatel +"' AND "
                        + "ID_dokument = '" + dokument + "'";
                    if (debug) Console.WriteLine(query);
                    prikaz = new SqlCommand(query, conn);
                    prikaz.ExecuteNonQuery();
                }
                //zaznam neexistuje pridame novy
                else
                {
                    conn.Close();
                    conn = new SqlConnection(this.conn_string);
                    conn.Open();
                    if (debug) Console.WriteLine("Pridavam hodnoty");

                    query = "INSERT INTO pocetnostOtvoreni (ID_pouzivatel, ID_dokument, pocetnost) values("
                        + " " + pouzivatel + " "
                        +", " + dokument + " "
                        +", 1)";
                    if (debug) Console.WriteLine(query);
                    prikaz = new SqlCommand(query, conn);
                    prikaz.ExecuteNonQuery();

                }

                if (debug) Console.WriteLine("Pocet otvoreni zvyseny");

            }
            finally
            {
                conn.Close();
            }

        }

        /************************************************************************************
        * 
        * Prida prepojenie medzi dvoma dokumentami
        * 
        * **********************************************************************************/
        public void pridajPrepojenie(int dokument1, int dokument2, int typ_prepojenia, float relevancia)
        {
            SqlConnection conn = new SqlConnection(this.conn_string);
            conn.Open();
            try
            {
                if (debug) Console.WriteLine("Pridavam prepojenie");

                string query = "INSERT INTO prepojeniaDokumentov(dok1, dok2, typ, relevancia) VALUES("
                + "" + dokument1 + ""
                + ", " + dokument2 + ""
                + ", " + typ_prepojenia + ""
                + ", " + relevancia.ToString().Replace(',','.') + ")";

                if (debug) Console.WriteLine(query);
                SqlCommand prikaz = new SqlCommand(query, conn);
                prikaz.ExecuteNonQuery();
                if (debug) Console.WriteLine("Prepojenie pridane");
            }
            finally
            {
                conn.Close();
            }

        }

        /************************************************************************************
         * 
         * najde dokumenty ktore su prepojene s danym dokumentom
         * 
         * **********************************************************************************/
        public Prepojenie[] vratPrepojenia(int ID_dokumentu)
        {
            Prepojenie[] vratit;
            SqlConnection conn = new SqlConnection(this.conn_string);
            conn.Open();
            try
            {
                if (debug) Console.WriteLine("Vyhladavam prepojenia");

                string query = "SELECT * FROM prepojeniaDokumentov WHERE dok1 = " + ID_dokumentu;

                if (debug) Console.WriteLine(query);
                SqlCommand prikaz = new SqlCommand(query, conn);

                SqlDataReader reader = null;
                reader = prikaz.ExecuteReader();

                LinkedList<Prepojenie> zoznam = new LinkedList<Prepojenie>();

                int i = 0;
                while (reader.Read())
                {
                    Prepojenie prepojenie = new Prepojenie();
                    prepojenie.dokument_ID = (int)reader["dok2"];
                    prepojenie.typ = (int)reader["typ"];
                    prepojenie.relevancia = (float)System.Convert.ToSingle((reader["relevancia"].ToString()));


                    if (i == 0) zoznam.AddFirst(prepojenie);
                    else zoznam.AddLast(prepojenie);
                    i++;
                }

                int pocet = zoznam.Count;

                vratit = new Prepojenie[pocet];

                zoznam.CopyTo(vratit, 0);

                for (i = 0; i < pocet; i++)
                {
                    if (debug) Console.WriteLine(vratit[i].dokument_ID + " " + vratit[i].typ + " " + vratit[i].relevancia);
                }
                return vratit;
            }
            finally
            {
                conn.Close();
            }
        }

    }


}
