/***********************************************************************
* Nazov suboru: Kategorie.cs
* Autor: Zdenko Porubcan
* Datum vytvorenia: 16.12.2007
* 
* Popis:  popis sboru, jeho el, pozcia implementovanej asti v systme, *spoluprca s okolm
* Funkcie:  popis jednotlivch funkci, ktor sbor poskytuje
***********************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Collections;

namespace Foobe
{
  public class Kategorie
  {
    ArrayList nazvyKategorii = new ArrayList();
    float[,] matica;
    string vahy;

    // metoda na nacitanie kategorii
    public void NacitanieSuboru()
    {
      string[] nazvy;
      string[] pole;
      char[] oddelovac = { ' ' };

      ZozKategorii zoz = new ZozKategorii();
      nazvy = zoz.vratZoznam();

      try
      {
        for (int i = 0; i < nazvy.Length; i++)
        {
          nazvyKategorii.Add(nazvy[i]);
        }

        matica = new float[nazvyKategorii.Count, nazvyKategorii.Count];
          
        int poc = 0, x, y;
        float w;

        vahy.Trim();
        pole = vahy.Split(oddelovac);

        for (poc = 0; poc < pole.Length; poc += 3)
        {
          x = Int32.Parse(pole[poc]);
          y = Int32.Parse(pole[poc + 1]);
          w = float.Parse(pole[poc + 2]);

          matica[x, y] = w;
          matica[y, x] = w;
        }
      }

      catch (Exception e)
      {
        Console.WriteLine(e.ToString() + "Sbor je przdny.");
      }
    }

    // vratenie matice vztahov
    private float[,] vratMaticu()
    {
      return matica;
    }

    // vratenie vahy
    private float vratVahu(string kat1, string kat2)
    {
      float vaha;
      int i, j;

      i = nazvyKategorii.IndexOf(kat1);
      j = nazvyKategorii.IndexOf(kat2);
      vaha = matica[i, j];

      return vaha;
    }

    // vratenie nazvov kategorii
    public ArrayList vratNazvyKategorii()
    {
      return this.nazvyKategorii;
    }

    // vypocet a vratenie vypocitanych vah
    public Vysledok[] vypocetRelevancie(string kategoria, string vahyKategorii, Vysledok[] dokumenty)
    {
        vahy = vahyKategorii;

        float vaha;
      
      NacitanieSuboru();

      for (int i = 0; i < dokumenty.Length; i++)
      {
        vaha = vratVahu(kategoria, dokumenty[i].kategoria);
        dokumenty[i].relevancia = vaha * dokumenty[i].relevancia;
      }

      return dokumenty;
    }
  }
}
