/*
Copyright  2006 - 2007 Annpoint, s.r.o.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

-------------------------------------------------------------------------

NOTE: Reuse requires the following acknowledgement (see also NOTICE):
This product includes Seekafile Server (http://www.seekafile.org) 
developed by Annpoint, s.r.o.

*/

using Lucene.Net.Analysis;
using Lucene.Net.Documents;

namespace Seekafile.Plugin
{
	public interface IDocumentPlugin
	{
		/// <summary>
		/// Extracts the plain text from a file
		/// </summary>
		/// <param name="path">Full path to the file to be parsed.</param>
		/// <returns></returns>
		Document Document(string path);

		/// <summary>
		/// Which DotLucene Analyzer to use.
		/// </summary>
		Analyzer Analyzer(string path);
		
		/// <summary>
		/// Description for the Seekafile Manager.
		/// </summary>
		string Description {get;}
		
		
		string[] Extensions {get;}
	}
}
