/***********************************************************************
* Nazov suboru: UserDocHits.cs
* Autor: Daniel Princzkel
* Datum vytvorenia: 8.4.2008
* 
* Popis:  seriolizovatelna trieda pre ulozenie statistik otvorenych suborov konkretnymi uzivatelmi
* Funkcie:  serializcia, deserializcia, zpis do sboru a vytanie zo sboru
***********************************************************************/

using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

namespace Foobe
{
    [Serializable()]
    public class UserDocHits : ISerializable
    {
        public volatile int[][] hits;

        public UserDocHits(int[][] _hits) 
        {
            this.hits = _hits;
        }

        //Deserialization constructor.
        public UserDocHits(SerializationInfo info, StreamingContext ctxt)
        {
            //Get the values from info and assign them to the appropriate properties
            hits = (int[][])info.GetValue("HitId", typeof(int[][]));
            //EmpName = (String)info.GetValue("EmployeeName", typeof(string));
        }
                
        //Serialization function.
        public void GetObjectData(SerializationInfo info, StreamingContext ctxt)
        {
            //You can use any custom name for your name-value pair. But make sure you
            // read the values with the same name. For ex:- If you write hits as "HitId"
            // then you should read the same with "HitId"
            info.AddValue("HitId", hits);
        }

        //Serialize the object to a fileStream given by its name
        public static void WriteUDHtoFile(UserDocHits UDH, String fileName)
        {
            Stream stream;
            try
            {
                stream = File.Open(fileName, FileMode.Create);
                BinaryFormatter bformatter = new BinaryFormatter();
                Console.WriteLine("Writing UserDocHits info to file {0}", fileName);
                bformatter.Serialize(stream, UDH);
                stream.Close();
            }
            catch(Exception e) 
            {
                Console.WriteLine("Nastala chyba: {0}", e.Message);
            }

        }

        //read the object from a file
        public static void ReadUDHfromFile(UserDocHits UDH, String fileName)
        {
    
            UDH = null;
            Stream stream;    
            //Open the file written above and read values from it.
            try
            {
                stream = File.Open(fileName, FileMode.Open);
                BinaryFormatter bformatter = new BinaryFormatter();

                Console.WriteLine("Reading UserDocHits from file {0}", fileName);
                UDH = (UserDocHits)bformatter.Deserialize(stream);
                stream.Close();
            }
            catch (Exception e) 
            {
                Console.WriteLine("Nastala chyba: {0}", e.Message);
            }
        }

    }
}
