/***********************************************************************
* Nazov suboru: Prihlasovanie.cs
* Autor: Zdenko Porubcan
* Datum vytvorenia: 22.03.2008
* 
* Rozhranie na prihlasovanie sa pouzivatela do systemu
***********************************************************************/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using Foobe.FoobeServis;

namespace Foobe
{
  public partial class Prihlasovanie : Form
  {
    FoobeServis.FoobeServis service;
    string s;
    
    // KONSTRUKTOR
    public Prihlasovanie()
    {
      InitializeComponent();
    }

    // zatvorenie okna
    private void button2_Click(object sender, EventArgs e)
    {
      this.Close();
    }

    // OK
    private void button1_Click(object sender, EventArgs e)
    {
      bool kor;

      try
      {
        kor = verifikacia(textBox1.Text, maskedTextBox1.Text);
      }
      catch (System.Web.Services.Protocols.SoapException)
      {
        MessageBox.Show(this, "Sevis nedokaze odpovedat!", "Chyba!", MessageBoxButtons.OK);
        return;
      }
      catch (System.InvalidOperationException)
      {
        MessageBox.Show(this, "Chyba v komunikacii so serverom!", "Chyba!", MessageBoxButtons.OK);
        return;
      }

      if (!kor)
      {
        MessageBox.Show(this, "Zly login alebo password!", "Chyba!", MessageBoxButtons.OK);
        maskedTextBox1.Text = "";
        return;
      } 

      s = textBox1.Text;
      Thread t = new Thread(spust);
      t.Start();
      this.Close();
    }

    // spustenie rozhrania na vyhladavanie
    public void spust()
    {
      Vyhladavanie v = new Vyhladavanie(s);
      v.Text = "Vyhadvanie dokumentov - " + s;
      Application.Run(v);
    }

    // verifikacia
    private bool verifikacia(string login, string password)
    {
        service = new FoobeServis.FoobeServis();
        return service.overLogin(login, password);
    }

    // ok
    private void spust_tbx(object sender, System.Windows.Forms.KeyPressEventArgs e)
    {
      if (e.KeyChar == (char)13)
      {
        bool kor;

        try
        {
          kor = verifikacia(textBox1.Text, maskedTextBox1.Text);
        }
        catch (System.Web.Services.Protocols.SoapException)
        {
          MessageBox.Show(this, "Sevis nedokaze odpovedat!", "Chyba!", MessageBoxButtons.OK);
          return;
        }
        catch (System.InvalidOperationException)
        {
          MessageBox.Show(this, "Chyba v komunikacii so serverom!", "Chyba!", MessageBoxButtons.OK);
          return;
        }

        if (!kor)
        {
          MessageBox.Show(this, "Zly login alebo password!", "Chyba!", MessageBoxButtons.OK);
          maskedTextBox1.Text = "";
          return;
        }

        s = textBox1.Text;
        Thread t = new Thread(spust);
        t.Start();
        this.Close();
      }
    }

    // nastavenie servera
    private void label3_Click(object sender, EventArgs e)
    {
      NastavenieServera ns = new NastavenieServera(service);
      ns.Visible = true;
    }

    // main
    static void Main()
    {
      Application.Run(new Prihlasovanie());
    }
  }
}