/***********************************************************************
* Nazov suboru: Progress.cs
* Autor: Zdenko Porubcan
* Datum vytvorenia: 17.04.2008
* 
* Rozhranie na nastavenie vah jednotlivych modulov
***********************************************************************/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Foobe.FoobeServis;

namespace Foobe
{
  public partial class Vahy : Form
  {
    FoobeServis.FoobeServis servis = new FoobeServis.FoobeServis();
    string login;
    float[] vahy;

    // KONSTRUKTOR
    public Vahy(string l)
    {
      login = l;
      vahy = servis.vratVahyModulov(login);

      InitializeComponent();
      trackBar1.Value = (int)(vahy[0]*100);
      trackBar2.Value = (int)(vahy[2]*100);
      trackBar3.Value = (int)(vahy[3]*100);

      textBox1.Text = (vahy[0] * 100).ToString();
      textBox2.Text = (vahy[2] * 100).ToString();
      textBox3.Text = (vahy[3] * 100).ToString();
    }

    // trackbar 1
    private void trackBar1_OnValueChanged(object sender, EventArgs e)
    {
      textBox1.Text = trackBar1.Value.ToString();
    }

    // trackbar 2
    private void trackBar2_OnValueChanged(object sender, EventArgs e)
    {
      textBox2.Text = trackBar2.Value.ToString();
    }

    // trackbar 3
    private void trackBar3_OnValueChanged(object sender, EventArgs e)
    {
      textBox3.Text = trackBar3.Value.ToString();
    }

    // ulozit hodnoty
    private void button1_Click(object sender, EventArgs e)
    {
      normovanie();

      //if (servis.zmenVahyModulov(login, float.Parse(textBox1.Text), float.Parse(textBox2.Text), float.Parse(textBox3.Text), float.Parse(textBox4.Text)))
      if (servis.zmenVahyModulov(login, vahy[0].ToString().Replace(',', '.'), "1.0", vahy[2].ToString().Replace(',', '.'), vahy[3].ToString().Replace(',', '.')))
      {
        MessageBox.Show(this, "Vhy boli uloen", "OK", MessageBoxButtons.OK);
      }
      else
      {
        MessageBox.Show(this, "Chyba pri ukladan vh!", "Chyba!", MessageBoxButtons.OK);
        return;
      }
    }

    // zatvorit
    private void button2_Click(object sender, EventArgs e)
    {
      this.Close();
    }

    // normovanie vah
    private void normovanie()
    {
      float a = float.Parse(textBox1.Text.ToString());
      float b = float.Parse(textBox2.Text.ToString());
      float c = float.Parse(textBox3.Text.ToString());

      float sum = a + b + c;

      vahy[0] = 1 / (sum / a);
      vahy[2] = 1 / (sum / b);
      vahy[3] = 1 / (sum / c);

      trackBar1.Value = (int)(vahy[0] * 100);
      trackBar2.Value = (int)(vahy[2] * 100);
      trackBar3.Value = (int)(vahy[3] * 100);

      textBox1.Text = (vahy[0] * 100).ToString();
      textBox2.Text = (vahy[2] * 100).ToString();
      textBox3.Text = (vahy[3] * 100).ToString();
    }
  }
}